org.apache.velocity.tools.generic

## Class AlternatorTool

- java.lang.Object
- - org.apache.velocity.tools.generic.SafeConfig
  - - org.apache.velocity.tools.generic.AlternatorTool

All Implemented Interfaces:
  Serializable

Deprecated.
use CSS3 nth-child(even/odd) selectors or #if($foreach.index % 2)

    @ValidScope(value="application")
     @DefaultKey(value="alternator")
     @Deprecated
    public class AlternatorTool
    extends SafeConfig
    implements Serializable

Simple tool to provide easy in-template instantiation of `Alternator`s from varying "list" types or individual arguments.

Example Use:

     tools.xml...
     <tools>
       <toolbox scope="application">
         <tool class="org.apache.velocity.tools.generic.AlternatorTool"/>
       </toolbox>
     </tools>

     template...
     #set( $color = $alternator.auto('red', 'blue') )
     ## use manual alternation for this one
     #set( $style = $alternator.manual('hip','fly','groovy') )
     #foreach( $i in [1..5] )
       Number $i is $color and $style. I dig $style.next numbers.
     #end *

     output...
       Number 1 is red and hip. I dig hip numbers.
       Number 2 is blue and fly. I dig fly numbers.
       Number 3 is red and groovy. I dig groovy numbers.
       Number 4 is blue and hip. I dig hip numbers.
       Number 5 is red and fly. I dig fly numbers.

Since:
  Velocity Tools 1.2
Version:
  $Revision$ $Date$
See Also:
  Serialized Form

### Field Summary

Fields
`static String` `AUTO_ALTERNATE_DEFAULT_KEY` Deprecated.

### Fields inherited from class org.apache.velocity.tools.generic.SafeConfig

`LOCK_CONFIG_KEY, log, LOGGER_NAME_KEY, SAFE_MODE_KEY, USE_CLASS_LOGGER_KEY`

### Constructor Summary

Constructors
Constructor and Description
`AlternatorTool()` Deprecated.

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`Alternator` `auto(Object... list)` Deprecated. Make an automatic `Alternator` from the specified objects.
`protected void` `configure(ValueParser parser)` Deprecated. Looks for a default auto-alternate value in the given params, if not, set the default to true.
`boolean` `getAutoAlternateDefault()` Deprecated. Returns true if the default for auto-alternating is true.
`Alternator` `make(boolean auto, Object... list)` Deprecated. Returns a new Alternator for the specified list with the specified automatic shifting preference.
`Alternator` `make(Object... list)` Deprecated. Make an automatic `Alternator` from the specifed objects.
`Alternator` `manual(Object... list)` Deprecated. Make a manual `Alternator` from the specified objects.
`protected void` `setAutoAlternateDefault(boolean bool)` Deprecated. Sets the default for auto-alternating.

### Methods inherited from class org.apache.velocity.tools.generic.SafeConfig

`configure, getLog, initLogger, isConfigLocked, isSafeMode, setLockConfig, setSafeMode`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### AUTO_ALTERNATE_DEFAULT_KEY

    public static final String AUTO_ALTERNATE_DEFAULT_KEY

Deprecated.

See Also:
  Constant Field Values

### Constructor Detail

#### AlternatorTool

    public AlternatorTool()

Deprecated.

### Method Detail

#### configure

    protected void configure(ValueParser parser)

Deprecated.
Looks for a default auto-alternate value in the given params, if not, set the default to true.

Overrides:
  `configure` in class `SafeConfig`
Parameters:
  `parser` - configuration values

#### getAutoAlternateDefault

    public boolean getAutoAlternateDefault()

Deprecated.
Returns true if the default for auto-alternating is true.

Returns:
  flag value
Since:
  VelocityTools 1.3

#### setAutoAlternateDefault

    protected void setAutoAlternateDefault(boolean bool)

Deprecated.
Sets the default for auto-alternating.

Parameters:
  `bool` - flag value
Since:
  VelocityTools 1.3

#### make

    public Alternator make(Object... list)

Deprecated.
Make an automatic `Alternator` from the specifed objects.

Parameters:
  `list` - values to alternate over
Returns:
  alternator

#### make

    public Alternator make(boolean auto,
                           Object... list)

Deprecated.
Returns a new Alternator for the specified list with the specified automatic shifting preference.

Parameters:
  `auto` - See `Alternator.setAuto(boolean auto)`.
  `list` - The list of elements to alternate.
Returns:
  alternator

#### auto

    public Alternator auto(Object... list)

Deprecated.
Make an automatic `Alternator` from the specified objects.

Parameters:
  `list` - objects to alternate over
Returns:
  a new, automatic Alternator with the specified values or `null` if there are none specified.
Since:
  VelocityTools 1.3

#### manual

    public Alternator manual(Object... list)

Deprecated.
Make a manual `Alternator` from the specified objects.

Parameters:
  `list` - objects to alternate over
Returns:
  a new, manual Alternator with the values in the array or `null` if the array is `null`.
Since:
  VelocityTools 1.3